<!doctype html>
<html class="no-js" lang="">
    <head>
        <meta charset="utf-8">
        <meta http-equiv="x-ua-compatible" content="ie=edge">
        <title>Nodejs-demo-NestJs-and-BDD documentation</title>
        <meta name="description" content="">
        <meta name="viewport" content="width=device-width, initial-scale=1">

        <link rel="icon" type="image/x-icon" href="./images/favicon.ico">
	   <link rel="stylesheet" href="./styles/style.css">
        <link rel="stylesheet" href="./styles/dark.css">
        <link rel="stylesheet" href="./styles/postmark.css">
    </head>
    <body>
          <script>
               // Blocking script to avaoid flickering dark mode
               // Dark mode toggle button
               var useDark = window.matchMedia('(prefers-color-scheme: dark)');
               var darkModeState = useDark.matches;
               var $darkModeToggleSwitchers = document.querySelectorAll('.dark-mode-switch input');
               var $darkModeToggles = document.querySelectorAll('.dark-mode-switch');
               var darkModeStateLocal = localStorage.getItem('compodoc_darkmode-state');

               function checkToggle(check) {
                    for (var i = 0; i < $darkModeToggleSwitchers.length; i++) {
                         $darkModeToggleSwitchers[i].checked = check;
                    }
               }

               function toggleDarkMode(state) {
                    if (window.localStorage) {
                         localStorage.setItem('compodoc_darkmode-state', state);
                    }

                    checkToggle(state);

                    const hasClass = document.body.classList.contains('dark');

                    if (state) {
                         for (var i = 0; i < $darkModeToggles.length; i++) {
                              $darkModeToggles[i].classList.add('dark');
                         }
                         if (!hasClass) {
                              document.body.classList.add('dark');
                         }
                    } else {
                         for (var i = 0; i < $darkModeToggles.length; i++) {
                              $darkModeToggles[i].classList.remove('dark');
                         }
                         if (hasClass) {
                              document.body.classList.remove('dark');
                         }
                    }
               }

               useDark.addEventListener('change', function (evt) {
                    toggleDarkMode(evt.matches);
               });
               if (darkModeStateLocal) {
                    darkModeState = darkModeStateLocal === 'true';
               }
               toggleDarkMode(darkModeState);

               if ($darkModeToggles.length > 0) {
                    for (var i = 0; i < $darkModeToggleSwitchers.length; i++) {
                         $darkModeToggleSwitchers[i].addEventListener('change', function (event) {
                              darkModeState = !darkModeState;
                              toggleDarkMode(darkModeState);
                         });
                    }
               }
          </script>

        <div class="navbar navbar-default navbar-fixed-top d-block d-sm-none">
            <a href="./" class="navbar-brand">Nodejs-demo-NestJs-and-BDD documentation</a>
            <button type="button" class="btn btn-default btn-menu ion-ios-menu" id="btn-menu"></button>
        </div>

        <div class="xs-menu menu" id="mobile-menu">
                <div id="book-search-input" role="search"><input type="text" placeholder="Type to search"></div>            <compodoc-menu></compodoc-menu>
        </div>

        <div class="container-fluid main">
           <div class="row main">
               <div class="hidden-xs menu">
                   <compodoc-menu mode="normal"></compodoc-menu>
               </div>
               <!-- START CONTENT -->
               <div class="content getting-started">
                   <div class="content-data">

<h1>Nodejs demo (NestJs and BDD)</h1>
<p>EasyGuide Nodejs boilerplate  (NestJs and BDD) </p>
<ul>
<li>Powered by EasyGuide.tech Inc</li>
<li>version 0.1<blockquote>
<p><strong>Alert note:</strong>  This application is for demonstration purpose only and it is not intended for use in a specific production. It is too generic and not designed to be particularly efficient, stable, or secure. It does not support all the required features and specific needs of a complete production-ready solution !</p>
</blockquote>
</li>
</ul>
<hr>
<p>Website : <a href="https://easyguide.tech">https://easyguide.tech</a></p>
<p><img src="EasyGuide_handbook.jpg" alt="EasyTech_IDE_handbook.jpg" class="img-responsive"></p>
<hr>
<h2><strong>TABLE OF CONTENTS</strong></h2>
<!-- @import "[TOC]" {cmd="toc" depthFrom=1 depthTo=6 orderedList=false} -->

<!-- code_chunk_output -->

<ul>
<li><a href="#overview">Overview</a></li>
<li><a href="#installation">Installation</a></li>
<li><a href="#running-the-app">Running the app</a></li>
<li><a href="#test">Test</a></li>
<li><a href="#bdd-test">BDD Test</a></li>
<li><a href="#code-source-documentation-with-compodoc">Code source documentation (With compodoc)</a></li>
<li><a href="#openapiswagger-documentation">OpenApi/Swagger documentation</a></li>
<li><a href="#async-api-kafka-documentation-optional">Async Api / Kafka documentation (Optional)</a></li>
<li><a href="#fake-third-app-and-server-side-render-view-with-handlebar">Fake third app and server-side render view with handlebar</a></li>
<li><a href="#use-our-custom-logger-service">Use our Custom Logger service</a></li>
<li><a href="#ci-cd">CI / CD</a></li>
<li><a href="#support">Support</a></li>
<li><a href="#source">Source</a></li>
<li><a href="#copyright-and-license">Copyright and License</a></li>
</ul>
<!-- /code_chunk_output -->

<hr>
<h2>Features</h2>
<p><a href="https://github.com/nestjs/nest">Nest</a> framework TypeScript starter repository.</p>
<p>A progressive Node.js framework for building efficient and scalable server-side applications with BDD tools.</p>
<p><img src="preview-demo.gif" alt="preview-demo.gif" class="img-responsive"></p>
<table class="table table-bordered compodoc-table">
<thead>
<tr>
<th>Method</th>
<th>Endpoint</th>
</tr>
</thead>
<tbody>
<tr>
<td><strong>Default</strong></td>
<td></td>
</tr>
<tr>
<td>GET</td>
<td>/</td>
</tr>
<tr>
<td>GET</td>
<td>/docs</td>
</tr>
<tr>
<td>GET</td>
<td>/ping</td>
</tr>
<tr>
<td><strong>Backend fake third app</strong></td>
<td></td>
</tr>
<tr>
<td>GET</td>
<td>/units</td>
</tr>
<tr>
<td>POST</td>
<td>/units</td>
</tr>
<tr>
<td>GET</td>
<td>/units/{id}</td>
</tr>
<tr>
<td>PATCH</td>
<td>/units/{id}</td>
</tr>
<tr>
<td>PUT</td>
<td>/units/{id}</td>
</tr>
<tr>
<td>DELETE</td>
<td>/units/{id}</td>
</tr>
<tr>
<td><strong>Front fake third app</strong></td>
<td></td>
</tr>
<tr>
<td>GET</td>
<td>/front/assets/{imgId}</td>
</tr>
<tr>
<td>GET</td>
<td>/front/units/new</td>
</tr>
<tr>
<td>GET</td>
<td>/front/units/{id}/edit</td>
</tr>
<tr>
<td>POST</td>
<td>/front/units/{id}/update</td>
</tr>
<tr>
<td>GET</td>
<td>/front/units/{id}/delete</td>
</tr>
<tr>
<td>GET</td>
<td>/front/units/{id}</td>
</tr>
<tr>
<td>GET</td>
<td>/front/units</td>
</tr>
<tr>
<td>POST</td>
<td>/front/units</td>
</tr>
<tr>
<td>GET</td>
<td>/front/login</td>
</tr>
<tr>
<td>POST</td>
<td>/front/login</td>
</tr>
<tr>
<td>GET</td>
<td>/front/register</td>
</tr>
<tr>
<td>POST</td>
<td>/front/register</td>
</tr>
<tr>
<td>GET</td>
<td>/front/success</td>
</tr>
<tr>
<td>GET</td>
<td>/front/failed</td>
</tr>
<tr>
<td>GET</td>
<td>/front</td>
</tr>
</tbody>
</table>
<h2>Installation</h2>
<b>Example :</b><div><pre class="line-numbers"><code class="language-bash">$ npm install</code></pre></div><h2>Running the app</h2>
<b>Example :</b><div><pre class="line-numbers"><code class="language-bash"># development
$ npm run start

# watch mode
$ npm run start:dev

# production mode
$ npm run start:prod</code></pre></div><h2>Test</h2>
<b>Example :</b><div><pre class="line-numbers"><code class="language-bash"># unit tests
$ npm run test

# e2e tests
$ npm run test:e2e

# test coverage
$ npm run test:cov
</code></pre></div><h2>BDD Test</h2>
<b>Example :</b><div><pre class="line-numbers"><code class="language-sh"># acceptance tests
$ npm run bdd:test

# Refresh acceptance test coverage
$ npm run bdd:report</code></pre></div><h2>Code source documentation (With compodoc)</h2>
<p>This documentation is automatically generated and available at <code>/docs/compodoc</code> url</p>
<p>the command script for the generation is <code>npm run compodoc</code></p>
<ul>
<li><strong>Note:</strong> All the technical documentations of this application can be found by entering this main url <code>/docs/compodoc</code><ul>
<li>Async API / Kafka</li>
<li>BDD / Cucumber</li>
<li>OpenAPI / Swagger</li>
<li>Test reports</li>
</ul>
</li>
</ul>
<h2>OpenApi/Swagger documentation</h2>
<p>This documentation is automatically generated and available at <code>/api</code> url</p>
<ul>
<li>Edit the <code>src\main.ts</code>  fie to update the title and description of the swagger documentation</li>
</ul>
<b>Example :</b><div><pre class="line-numbers"><code class="language-ts">const config = new DocumentBuilder()
      .setTitle(&#39;API Docs&#39;)
      .setDescription(&#39;The API documentation&#39;)
      .setVersion(&#39;1.0&#39;)
      //.addTag(&#39;Nestjs starter&#39;)
      .build();</code></pre></div><ul>
<li>Use the tag <code>@ApiTags()</code> to specify a section in api documentation:</li>
</ul>
<b>Example :</b><div><pre class="line-numbers"><code class="language-ts">&#64;ApiTags(&#39;backend fake third app&#39;)
&#64;Controller(&#39;units&#39;)
// ...</code></pre></div><ul>
<li><strong>Note:</strong> Documentation will not detect your interface type definition as DTO or Entity (Typescript issue)
You must declare them as a class and not an interface. See more info  in this link : [<a href="https://github.com/nestjs/nest/issues/339%5D">https://github.com/nestjs/nest/issues/339]</a></li>
</ul>
<b>Example :</b><div><pre class="line-numbers"><code class="language-ts">import { ApiProperty } from &#39;&#64;nestjs/swagger&#39;;

export class UnitEntity {
  &#64;IsString()
  // You can use the &#64;ApiProperty tag to add some example and description in swagger documentation
  &#64;ApiProperty({ example: &#39;608ab7e27a84420dfc16b335&#39;, description: &#39;The ID&#39; })
  id: string;
}</code></pre></div><ul>
<li><p><strong>Notes:</strong> Use the <code>@ApiProperty</code> tag to add some example and description for the swagger documentation of entities</p>
</li>
<li><p><strong>Note:</strong> Swagger doc <code>/api</code> url is not available in production mode for security reason</p>
</li>
</ul>
<h2>Async Api / Kafka documentation (Optional)</h2>
<p>You will have to manualy edit the <code>docs\asyncapi-kafka\asyncapi-spec.yml</code> file</p>
<p>the command script for the generation is <code>npm run asyncapi-doc</code> and is already included in the command <code>npm run compodoc</code> so this documentation is automatically generated and available at <code>/docs/compodoc</code> url</p>
<h2>Fake third app and server-side render view with handlebar</h2>
<p>An optional module <code>fake-third-app</code> can be used to simulate a third api or third app with fake data and server-side frontend render view (using handlebars template engine)</p>
<h2>Use our Custom Logger service</h2>
<ul>
<li><strong>Insert:</strong></li>
</ul>
<b>Example :</b><div><pre class="line-numbers"><code class="language-ts">&#64;Injectable()
export class MyService {
  errorContext: string;
  units: UnitsDto;

  constructor(
    &#64;Inject(WINSTON_MODULE_PROVIDER) private readonly logger: Logger,
  ) {
    this.errorContext = &#39;My-api.MyModule.MyService&#39;;
  }</code></pre></div><ul>
<li><strong>Use:</strong></li>
</ul>
<b>Example :</b><div><pre class="line-numbers"><code class="language-ts">try {
  this.logger.info(`${this.errorContext}.getUnits().begun`);
  //...
  if (!units){
    throw Error(`Units data loading failed`);
  }
} catch (err) {
  const errorMessage: string = `${this.errorContext}.getUnits().failed: ${err}`;
  this.logger.error(errorMessage);
  throw errorMessage;
}</code></pre></div><ul>
<li><strong>Note:</strong> For more advanced logging functionality, you can make use of any Node.js logging package, such as Winston, to implement a completely custom, production grade logging system.</li>
</ul>
<h2>CI / CD</h2>
<p>See <a href=""></a></p>
<h2>Support</h2>
<p>Nest is an MIT-licensed open source project. It can grow thanks to the sponsors and support by the amazing backers. If you&#39;d like to join them, please <a href="https://docs.nestjs.com/support">read more here</a>.</p>
<h2>Source</h2>
<ul>
<li>Github: <a href="https://github.com/nestjs/typescript-starter">https://github.com/nestjs/typescript-starter</a></li>
<li>Author - <a href="https://twitter.com/kammysliwiec">Kamil Myśliwiec</a></li>
<li>Website - <a href="https://nestjs.com/">https://nestjs.com</a></li>
<li>Twitter - <a href="https://twitter.com/nestframework">@nestframework</a></li>
</ul>
<h2>Copyright and License</h2>
<ul>
<li>This project is released under the MIT expat license and the EasyGuide.tech EE LICENSE</li>
</ul>
<ul>
<li>see the <a href="LICENSE.md">LICENSE.md</a> file for details.</li>
<li>see the <a href="ee/EE-LICENSE.md">EE-LICENSE.md</a> file for details.</li>
</ul>
<ul>
<li><strong>Note:</strong> Nest is <a href="https://github.com/nestjs/nest/blob/master/LICENSE">MIT licensed</a>.</li>
</ul>
<p>The package is Open core Source released under the <a href="LICENSE">MIT Expat</a> with DCO requirement for contributing (Developer Certificate of Origin).</p>
<p>It is developed by cheikhna diouf and derived from his official book &quot;Easy Guide ! A new method&quot; which you can buy as printed book or as ebook on official website, Amazon, Google Play and the iBooks Store.</p>
<p><img src="EasyGuide_Collection.jpg" alt="EasyGuide_Collection.jpg" class="img-responsive"></p>





















                   </div><div class="search-results">
    <div class="has-results">
        <h1 class="search-results-title"><span class='search-results-count'></span> results matching "<span class='search-query'></span>"</h1>
        <ul class="search-results-list"></ul>
    </div>
    <div class="no-results">
        <h1 class="search-results-title">No results matching "<span class='search-query'></span>"</h1>
    </div>
</div>
</div>
               <!-- END CONTENT -->
           </div>
       </div>

          <label class="dark-mode-switch">
               <input type="checkbox">
               <span class="slider">
                    <svg class="slider-icon" viewBox="0 0 24 24" fill="none" height="20" stroke="#000" stroke-linecap="round" stroke-linejoin="round" stroke-width="2" width="20" xmlns="http://www.w3.org/2000/svg">
                    <path d="M21 12.79A9 9 0 1111.21 3 7 7 0 0021 12.79z"></path>
                    </svg>
               </span>
          </label>

       <script>
            var COMPODOC_CURRENT_PAGE_DEPTH = 0;
            var COMPODOC_CURRENT_PAGE_CONTEXT = 'getting-started';
            var COMPODOC_CURRENT_PAGE_URL = 'index.html';
            var MAX_SEARCH_RESULTS = 15;
       </script>

       <script src="./js/libs/custom-elements.min.js"></script>
       <script src="./js/libs/lit-html.js"></script>

       <script src="./js/menu-wc.js" defer></script>
       <script nomodule src="./js/menu-wc_es5.js" defer></script>

       <script src="./js/libs/bootstrap-native.js"></script>

       <script src="./js/libs/es6-shim.min.js"></script>
       <script src="./js/libs/EventDispatcher.js"></script>
       <script src="./js/libs/promise.min.js"></script>
       <script src="./js/libs/zepto.min.js"></script>

       <script src="./js/compodoc.js"></script>

       <script src="./js/tabs.js"></script>
       <script src="./js/menu.js"></script>
       <script src="./js/libs/clipboard.min.js"></script>
       <script src="./js/libs/prism.js"></script>
       <script src="./js/sourceCode.js"></script>
          <script src="./js/search/search.js"></script>
          <script src="./js/search/lunr.min.js"></script>
          <script src="./js/search/search-lunr.js"></script>
          <script src="./js/search/search_index.js"></script>
       <script src="./js/lazy-load-graphs.js"></script>


    </body>
</html>
